
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Cover_artworksDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const cover_artworks = await db.cover_artworks.create(
            {
                id: data.id || undefined,
        
        prompt: data.prompt
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await cover_artworks.setSong( data.song || null, {
            transaction,
        });
        
        await cover_artworks.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.cover_artworks.getTableName(),
                belongsToColumn: 'art_images',
                belongsToId: cover_artworks.id,
            },
            data.art_images,
            options,
        );
        

        return cover_artworks;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const cover_artworksData = data.map((item, index) => ({
                id: item.id || undefined,
                
                prompt: item.prompt
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const cover_artworks = await db.cover_artworks.bulkCreate(cover_artworksData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < cover_artworks.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.cover_artworks.getTableName(),
                    belongsToColumn: 'art_images',
                    belongsToId: cover_artworks[i].id,
                },
                data[i].art_images,
                options,
            );
        }
        

        return cover_artworks;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const cover_artworks = await db.cover_artworks.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.prompt !== undefined) updatePayload.prompt = data.prompt;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await cover_artworks.update(updatePayload, {transaction});

        
        
        if (data.song !== undefined) {
            await cover_artworks.setSong(
              
              data.song,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await cover_artworks.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.cover_artworks.getTableName(),
                belongsToColumn: 'art_images',
                belongsToId: cover_artworks.id,
            },
            data.art_images,
            options,
        );
        

        return cover_artworks;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const cover_artworks = await db.cover_artworks.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of cover_artworks) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of cover_artworks) {
                await record.destroy({transaction});
            }
        });


        return cover_artworks;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const cover_artworks = await db.cover_artworks.findByPk(id, options);

        await cover_artworks.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await cover_artworks.destroy({
            transaction
        });

        return cover_artworks;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const cover_artworks = await db.cover_artworks.findOne(
            { where },
            { transaction },
        );

        if (!cover_artworks) {
            return cover_artworks;
        }

        const output = cover_artworks.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.song = await cover_artworks.getSong({
            transaction
        });
        
        
        output.art_images = await cover_artworks.getArt_images({
            transaction
        });
        
        
        output.organizations = await cover_artworks.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.songs,
        as: 'song',
        
        where: filter.song ? {
          [Op.or]: [
            { id: { [Op.in]: filter.song.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.song.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'art_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.prompt) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'cover_artworks',
                        'prompt',
                        filter.prompt,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.cover_artworks.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'cover_artworks',
                        'prompt',
                        query,
                    ),
                ],
            };
        }

        const records = await db.cover_artworks.findAll({
            attributes: [ 'id', 'prompt' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['prompt', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.prompt,
        }));
    }

    
};

